/* CMC_BorrowerSingSQL Version 1.5
 * Copyright 1999 Michael Claudius, Inc. All Rights Reserved.
 * Last modified 2003.10.19, 2005.11.13
 * All rights reserved
 */

package LibraryDatabase2007;

import java.sql.*;

public class CMC_BorrowerSingleSQL {
    
    Statement stmt;
    //DMC_LibrarySingleton singleton; not necessary as we go through statement stmt
    
    //Default constructor
    CMC_BorrowerSingleSQL(){
        stmt = DMC_LibrarySingleton.getStatement();
        //alternatively if we need singleton for other purposes
        //singleton = DMC_LibrarySingleton.getSingleton();
        //stmt = singleton.getStatement();
    }
    
    public void connector() {
        stmt = DMC_LibrarySingleton.getStatement();
    }
    public static void closing() {
        DMC_LibrarySingleton.closing();
    }
    
    public int getNoOfBorrowers() {
        int no=0;
        try {
            String borrowerQuery = "select count(cprNo) from  borrower";
            ResultSet rs = stmt.executeQuery(borrowerQuery);
            if ( rs.next() ) no = rs.getInt(1);
        } catch(SQLException ex) {
            System.err.println(ex.getMessage());
            
        }
        return no;
    }
    
    public void addBorrowerDB(Borrower aBorrower) {
        try {
            String borrowerInsert = "insert into Borrower values ( " + aBorrower.toDBString() + ")";
            stmt.executeUpdate(borrowerInsert);
        } catch(SQLException ex) {
            System.err.println(ex.getMessage());
            
        }
        
    }
    
    
    public Borrower getBorrowerDB(String aCprNo) {
        String cprNo, name, bType, state;
        int year;
        Borrower borrower = null;;
        
        String borrowerSelect = "select * from Borrower where cprNo = "+ "\'" + aCprNo + "\'";
        
        try {
            ResultSet rs = stmt.executeQuery(borrowerSelect);
            if ( rs.next() ) {
                cprNo = rs.getString(1);
                name = rs.getString(2);
                year = rs.getInt(3);
                bType = rs.getString(4);
                state = rs.getString(5);
                
                borrower = new Borrower(cprNo, name, bType, year, state);
            }
        } catch(SQLException ex) {
            System.err.println(ex.getMessage());
        }
        
        //System.out.println("returning borrower");
        return borrower;
    }
    
    
    public void upDateBorrowerDB(String oldCprNo, Borrower aBorrower) {
        try {
            String cprNo = aBorrower.getCprNo();
            String borrowerUpdate = " update Borrower set " + aBorrower.toDBUpdateString() +
                    " where cprNo = "+ "\'" + oldCprNo + "\'";
            stmt.executeUpdate(borrowerUpdate);
        } catch(SQLException ex) {
            System.err.println(ex.getMessage());
        }
        
    }
    
    
    public Borrower deleteBorrowerDB(String aCprNo) {
        Borrower borrower = getBorrowerDB(aCprNo);
        if (borrower != null) {
            try {
                String borrowerDelete = "delete from Borrower where cprNo = "+ "\'" + aCprNo + "\'";
                stmt.executeUpdate(borrowerDelete);
            } catch(SQLException ex) {
                System.err.println(ex.getMessage());
            }
        }//if
        return borrower;
    }
    
    
    
    public ResultSet getAllBorrowersAsResultSet() {
        ResultSet rs = null;
        try {
            String borrowerSelect = "select * from Borrower" ;
            rs = stmt.executeQuery(borrowerSelect);
        } catch(SQLException ex) {
            System.err.println(ex.getMessage());
        }
        return rs;
    }
    
    
    public BorrowerCollection getAllBorrowersAsCollection() {
        String cprNo, name, bType, state;
        int year;
        Borrower borrower;
        BorrowerCollection borrowers  = new BorrowerCollection();
        
        String borrowerSelect = "select * from Borrower" ;
        
        try {
            ResultSet rs = stmt.executeQuery(borrowerSelect);
            while (rs.next()) {
                cprNo = rs.getString(1);
                name = rs.getString(2);
                bType = rs.getString(3);
                year = rs.getInt(4);
                state = rs.getString(5);
                
                borrower = new Borrower(cprNo, name, bType, year, state);
                borrowers.addBorrower(borrower);
            }
            
        } catch(SQLException ex) {
            System.err.println(ex.getMessage());
        }
        
        return borrowers;
    }
    
}// CMC_BorrowerSingleSQL
