/* DMC_LibrarySingleton Version 1.5
 * Copyright 1999 Michael Claudius, Inc. All Rights Reserved.
 * Last modified 2003.10.19, 2005.11.13
 * All rights reserved
 */
package LibraryDatabase2007;
import java.sql.*;

public  class DMC_LibrarySingleton {

// If You only want one stmt through the whole execution time use this
    //private static Connection con = DMC_LibrarySingleton.getConnection();
    //private static Statement stmt = DMC_LibrarySingleton.getStatement();

    private static DMC_Library dmc;
    private static DMC_LibrarySingleton singleton = new DMC_LibrarySingleton();
    
    // Establish connection and statement
    private DMC_LibrarySingleton() {
        dmc = new DMC_Library();
        dmc.connect();
    
// If You only want one stmt through the whole execution time use this
        //con =  dmc.getConnection();
        //stmt = dmc.getStatement();
    }
    
    public static DMC_LibrarySingleton getSingleton() {
        return singleton;
    }
    
    public static Statement getStatement() {
        return dmc.getStatement();
    }
    
    public static Connection getConnection() {
        return dmc.getConnection();
    }
    
    public static void closing() {
        dmc.close();
    }
    
}// DMC_LibrarySingleton
