/* Domain definitions  */

//drop table Lend;
//drop table Borrower;
//drop table Item;

EXEC sp_addtype cprNoDomain, 'CHAR(10)';
EXEC sp_addtype nameDomain, 'VARCHAR(30)';
EXEC sp_addtype bTypeDomain, 'VARCHAR(5)';
EXEC sp_addtype yearDomain, INTEGER;
EXEC sp_addtype stateDomain, 'VARCHAR(15)';

EXEC sp_addtype itemNoDomain, 'CHAR(5)';
EXEC sp_addtype titleDomain, 'CHAR(30)';
EXEC sp_addtype iTypeDomain, 'VARCHAR(15)';


create table Borrower
( cprNo	cprNoDomain NOT NULL,
  name	nameDomain NOT NULL,
  bType	bTypeDomain default ' ',
	constraint checkType 
	check(bType in (' ','Adult','Child') ),
  regYear yearDomain,
  state	stateDomain default 'Active',
	constraint checkState 
	check(state in ('Active','Illegal','Passive') ),
  primary key (cprNo)
);

create table Item
( itemNo itemNoDomain NOT NULL,
  title titleDomain NOT NULL,
  itemType iTypeDomain default'Unknown',
  regYear yearDomain,
  state	stateDomain default 'Registered',
	constraint checkItemState
	check(state in ('Registered','Lent','Lost') ),
  primary key (itemNo)
);

create table Lend
( cprNo cprNoDomain not null,
  itemNo itemNoDomain not null,
  returnDate Datetime not null,
  primary key (itemNo, cprNo, returnDate),
  foreign key (itemNo) references Item(itemNo)
	on delete no action on update cascade,
  foreign key (cprNo) references Borrower(cprNo)
	on delete no action on update cascade
);



