//Borrower.java

/* Author Michael Claudius, Roskilde Computer Science College
 * Version 1.0. 2007.03.20
 * Copyright 2007 by Michael Claudius
 * All rights reserved ?
 */
package LibraryDatabase2007;

import java.io.*;

public class Borrower implements Serializable {
     private String name, bType, cprNo, state = "Active";
    private int year = 9999;
    
// constructors for creating objects
    
    Borrower(){
        //default constructor
    }
    
    Borrower(String name, String bType, int year)  {
        //initialise all data fields to the parameters
        this.name = name;
        this.year = year;
        this.bType = bType;
    }
  Borrower(String cprNo, String name, String bType, int year)  {
        //initialise all data fields to the parameters
        this.cprNo = cprNo;
        this.name = name;
        this.year = year;
        this.bType = bType;
    }
    
    Borrower(String cprNo, String name, String bType, int year, String state)  {
        //initialise all data fields to the parameters
        this.cprNo = cprNo;
        this.name = name;
        this.year = year;
        this.bType = bType;
        this.state = state;
    }
    
    public String toString() {
        return ("\n" + "CprNo: " + cprNo +
        "\n" + "Name: " + name +
        "\n" + "Type: " + bType +
        "\n" + "Year of Registration: " + year +      
        "\n" + "State: " + state) ;
    }
    
    public String borrowerData() {
       return ("\n" + "CprNo: " + cprNo +
        "\n" + "Name: " + name +
        "\n" + "Type: " + bType +
        "\n" + "Year of Registration: " + year +      
        "\n" + "State: " + state) ;
    }
      
    public double calculateBill(int noItems, int noOfDays) {
        int price = 0;
        if (noOfDays > 21)
            price = 40;
        else
            if (noOfDays > 14)
                price = 25;
            else
                if (noOfDays > 7)
                    price = 10;
                else price = 0;
        
        double totalPrice = noItems*price;
        return totalPrice;
    }
    
    public String toDBString() {
        return ("\'"    +  cprNo +
        "\',\'" +  name  +
        "\',\'"   +  bType +"" +
        "\',"   +  year  +
        ",\'" +  state +
        "\'") ;
    }
    
    
    public String toDBUpdateString() {
        return ("cprNo = " + "\'" + cprNo + "\'," +
        "name  = " + "\'" + name  + "\'," +
        "bType = " + "\'" + bType + "\'," +
        "regYear   = " +  year   + "," +
        "state  = " + "\'" + state + "\'") ;
    }
    
    public String getName( )  {
        return name;  }
    
    public void setName(String aName)  {
        name = aName;
    }
    
    public String getBType() {
        return bType;
    }
    
    public void setBType(String bType) {
        this.bType = bType;
    }
    
    public int getYear() {
        return year;
    }
    
    public void setYear(int year) {
        this.year = year;
    }
    
  public java.lang.String getCprNo() {
        return cprNo;
    }
    
    public void setCprNo(java.lang.String cprNo) {
        this.cprNo = cprNo;
    }
    
    public java.lang.String getState() {
        return state;
    }
    
    public void setState(java.lang.String state) {
        this.state = state;
    }
    
    //Ass. 2b
    public static void main(String[] args) {
        // TODO code application logic here
        
        Borrower b1 = new Borrower("150561-7777", "The Boss", "Adult", 2005);
        b1.setName("Michael Claudius");
        Borrower b2 = new Borrower("15081-7777", "Zhen Zhao", "Adult", 2005, "Passive");
        System.out.println(b1.borrowerData());
        System.out.println(b2.borrowerData());
        System.out.println(b2.toDBUpdateString()); //uses toString per default
    }
    
}// Borrower

