/* CalendarCalculator Version 1.2
 * Copyright 2005 Michael Claudius, Inc. All Rights Reserved.
 * Last modified 2006.11.15, 2005.11.13
 * All rights reserved
 */
package LibraryDatabase2007;

//import java.sql.*; not necessary as we need to specify the package due to a Date class in util
import java.util.*;

public class CalendarCalculator {
    private static java.sql.Date toDay, checkDate, returnDate;
    /** Creates a new instance of Tester */
    private static CalendarCalculator instance = new CalendarCalculator();

    private CalendarCalculator() {

        Calendar cal = Calendar.getInstance();
        int year = cal.get(Calendar.YEAR);
        int month = cal.get(Calendar.MONTH)+1;
        int day = cal.get(Calendar.DAY_OF_MONTH);

        String aDate = year +"-"+month+"-"+day;
        this.toDay = java.sql.Date.valueOf(aDate);

        //returnDate is to be compared with today's date, if one uses a returnDate of a lend
        int day1 = day + 30;
        aDate = year +"-"+month+"-"+day1;
        this.returnDate = java.sql.Date.valueOf(aDate);

        //checkDate is to be compared eith lentDate, if one uses a lentDate as date of lend
        int day2 = day - 30;
        aDate = year +"-"+month+"-"+day2;
        this.checkDate = java.sql.Date.valueOf(aDate);
    }

    public static java.sql.Date getToday() {
        return toDay;
    }

        public static java.sql.Date getReturnDate() {
	return returnDate;
    }

    public static java.sql.Date getCheckDate() {
	return checkDate;
    }

    public static CalendarCalculator getInstance() {
        return instance;
    }

    public static void main(String[] args) {
        // TODO code application logic here
        //Printing the correct date for 2000 years 3 months and 55 days
        System.out.println(java.sql.Date.valueOf("2000-03-25")) ;
        System.out.println(java.sql.Date.valueOf("2000-03-55")) ;

        Calendar cal = Calendar.getInstance();
        int year = cal.get(Calendar.YEAR);
        int month = cal.get(Calendar.MONTH)+1; //MONTH are enumerated 0-11!
        int day = cal.get(Calendar.DAY_OF_MONTH);

        String lentDate = year +"-"+month+"-"+day;
        System.out.println(java.sql.Date.valueOf(lentDate)) ;

        //Subtracting 30 from today , now day becomes negative but its ok
        // valueOf calculates correct month day
        int day1 = day - 30;
        System.out.println("Day: " + day1) ;
        String checkDate = year +"-"+month+"-"+day1;
        System.out.println(java.sql.Date.valueOf(checkDate)) ;

        int day2 = day + 30;
        System.out.println("Day: " + day2) ;
        String returnDate = year +"-"+month+"-"+day2;
        System.out.println(java.sql.Date.valueOf(returnDate)) ;

        //Using class methods for calculations of today's date and returnday's checkDate
        System.out.println();
        System.out.println(CalendarCalculator.getToday() );
        System.out.println(CalendarCalculator.getCheckDate() );
       System.out.println(CalendarCalculator.getReturnDate() );
    }

}
